/*	Pouzivane klavesy:
	L - vypne osvetlenie
	T - vypne texturovanie
	F - vypne hmlu
	R - reset pohladu
	mys, tlacitka na mysi		- pohyb
	sipky, Page Up,Page Down	- pohyb
	shift - pomaly alebo rychli pohyb	
	Zavislost intenzity hmly od vzdialenosti sa meni:
	1 - exponencialna
	2 - exponencialna na druhu
	3 - linearna
*/

#include "init.h"
//tu moste ovlplyvnit rychlost, cim mensie cisla tym rychlejsi, minimum je 1 pre kazdy smer
#define pocet_kociek_v_smere_x 4
#define pocet_kociek_v_smere_y 2
#define pocet_kociek_v_smere_z 8

#define POCET_TEXTUR 2
GLuint	texture[POCET_TEXTUR];
char	texture_name[POCET_TEXTUR][20]={"data/font.bmp","data/textura.bmp"};

float	uholx,uholy,uholz,fps;
char	text[20];

float	angle_x,angle_y,angle_z,pos_x,pos_y,pos_z=7.0f;
POINT MouseBod;
const float piover180 = 0.01745329252f; // pi/180

GLuint	box[3];				// miesto pre cisla display listov

void ChangeCameraPosition(void)
{	float mys_x,mys_y,step;
	
	glLoadIdentity();					// reset matice pohladu (macitanie jednotkovej matice)
	if(keys['R']){angle_x=0;angle_y=0;angle_z=0;pos_z=7.0f;pos_x=0;pos_y=0;keys['R']=0;}
	if(keys[VK_SHIFT])step=5.0f/fps;else step=25.0f/fps;		//ak je stlaceny shift mensi krok
	if (keys[VK_UP] || keys[VK_LBUTTON])		// sipka hore alebo lave tlacidlo mysi
	{	
		pos_x += step * (float)sin(angle_y*piover180) * (float)cos(angle_x*piover180);
		pos_y -= step * (float)sin(angle_x*piover180);
		pos_z -= step * (float)cos(angle_y*piover180) * (float)cos(angle_x*piover180);
	}
	if (keys[VK_DOWN] || keys[VK_RBUTTON])		// sipka dole alebo prave tlacidlo mysi
	{
		pos_x -= step * (float)sin(angle_y*piover180) * (float)cos(angle_x*piover180);
		pos_y += step * (float)sin(angle_x*piover180);
		pos_z += step * (float)cos(angle_y*piover180) * (float)cos(angle_x*piover180);
	}

	GetCursorPos(&MouseBod);						//nacitanie pozicie mysi
	SetCursorPos(obraz_x/2,obraz_y/2);				//nastavenie pozicie mysi na stred obrazovky
	mys_x= ((float)MouseBod.x - obraz_x/2)/10;		//vypocet zmeny pozicie mysi v smere x
	mys_y= ((float)MouseBod.y - obraz_y/2)/10;		//vypocet zmeny pozicie mysi v smere y
	if     (keys[VK_NEXT])mys_y=1;		//Page Down
	else if(keys[VK_PRIOR])mys_y=-1;	//Page Up
	if     (keys[VK_RIGHT])mys_x=1;		//sipka vpravo
	else if(keys[VK_LEFT])mys_x=-1;		//sipka vlavo
	angle_x+= mys_y;
	angle_y+= mys_x;

	if(angle_x>90.f) angle_x = 90.f;
	if(angle_x<-90.f) angle_x = -90.f;

	glRotatef(angle_x,1,0,0);
	glRotatef(angle_y,0,1,0);
//	glRotatef(angle_z,0,0,1);
	glTranslatef(-pos_x, -pos_y, -pos_z);
}


void DrawGLScene(void)				// vlastn kreslenie
{	float	x,y,z;
	//glLoadIdentity();				//Nahradi aktualnu maticu z identicku maticu
	//glTranslatef(0.0f,0.0f,-5.0f);	//nasoby aktualnu maticu z transformacnou maticou - posunie pociatok
	ChangeCameraPosition();			//volanie funkcie na otocenie a posunutie kamery

	if(!keys['L'])glEnable(GL_LIGHTING);		//ak nie je stlacene 'L' nezapne svetlo
	if(keys['T'])glDisable(GL_TEXTURE_2D);		//ak je stlacene 'T' vypne texturovanie
	//zavislost intenzity hmly od vzdialenosti
	if(keys['1'])glFogi(GL_FOG_MODE,GL_EXP);					//exponencialna
	else	if(keys['2'])glFogi(GL_FOG_MODE,GL_EXP2);			//exponencialna na druhu
			else	if(keys['3'])glFogi(GL_FOG_MODE,GL_LINEAR);	//linearna
	
	if(keys['F'])
		glClearColor(0.0f, 0.0f, 0.0f, 0.5f);	//nastavenie farby pozadia (na aku hodnotu sa maze buffer
	else
	{
		glClearColor(0.5f, 0.5f, 0.5f, 0.5f);	//nastavenie farby pozadia (na aku hodnotu sa maze buffer
		glEnable(GL_FOG);				//ak nie je stlacene 'F' nezapne hmlu
	}
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	//cisti buffer v aktualnom viewporte a to iba color a hlbkovy bit
	
	glColor3f(1.0f,1.0f,1.0f);		//biela farba
	glBindTexture(GL_TEXTURE_2D, texture[1]);		//nasavime aktualnu texturu pre textureovanie
	
	glPushMatrix();					//ulozenie (Modelview Matrix) modelovacej matice (matice pohladu)
	for(z=-4.0f*pocet_kociek_v_smere_z;z<0.0f;z+=4.0f)
	{	
		for(y=2.0f-2.0f*pocet_kociek_v_smere_y;y<2.0f+2.0f*pocet_kociek_v_smere_y;y+=4.0f)
		{
			for(x=2.0f-2.0f*pocet_kociek_v_smere_x;x<2.0f+2.0f*pocet_kociek_v_smere_x;x+=4.0f)
			{
				glPopMatrix();					//nacitanie mmodelovacej matice
				glPushMatrix();					//ulozenie matice
				glTranslatef(x,y,z);
				glRotatef(uholx,1,0,0);			//
				glRotatef(uholy,0,1,0);			// otocenie kocky
				glRotatef(uholz,0,0,1);			//

				glCallList(box[0]);				//kreslime kocku - tak ze zavolame display list
			}
		}
	}
	
	glPopMatrix();					//nacitanie mmodelovacej matice

	glDisable(GL_LIGHTING);					//vypnutie osvetlenia
	glDisable(GL_FOG);						//vypnutie hmly
	glEnable(GL_TEXTURE_2D);				//povolime texturovanie pre vypisovanie textu - v pripade ze je vypnute
	fps=(float)1.0f /(float)TimerGetTime(&timer0);
	TimerReset(&timer0);
	gcvt( (double)fps, 4, text);			//prevod realneho cisla na text
	glPrint_(0,0,text,0);					//vypisanie textu na 0 stlpec a 1 riadok

	if(keys['H'])
	{
		glPrint_(18,3,"Program: Display list and fog",0);
		glColor3f(0.9f,0.9f,1.0f);
		glPrint_(13,4,"Programmer: Marek Mizanin - www.mizanin.szm.sk",0);
		glColor3f(1.0f,1.0f,1.0f);
		glPrint_(15,6,"Control keys:",0);
		glPrint_(20,7,"L - lighting off",1);
		glPrint_(20,8,"T - texturing off",1);
		glPrint_(20,9,"F - fog off",1);
		glPrint_(20,10,"R - reset camera",1);
		glPrint_(20,11,"H - help",1);
		glPrint_(20,12,"mouse, button on mouse - moving",1);
		glPrint_(20,13,"arrow, Page Up,Page Down - moving",1);
		glPrint_(20,14,"shift - slow moving",1);
		glPrint_(15,16,"Equation for fog:",0);
		glPrint_(20,17,"1 - exponencial",1);
		glPrint_(20,18,"2 - exponencial to power of 2",1);
		glPrint_(20,19,"3 - linear",1);
	}
//	uholx+=0.1f;		//zvys uhol o 0.1  - tymto sa da menit rychlost rotacie
	uholy+=0.2f;		//zvys uhol o 0.2  - -""-
//	uholz+=0.25f;		//zvys uhol o 0.25 - -""-
}

AUX_RGBImageRec *LoadBMP(char *Filename)			// Natanie bitmapovho obrzka
{
	FILE *File=NULL;								// smernik na subor

	if (!Filename)return NULL;						// skka i meno sboru bolo zadan
	File=fopen(Filename,"r");						// otvorenie sboru na tanie
	if (File)										// existuje sbor ?
	{
		fclose(File);								// Uzatvorenie sbora
		return auxDIBImageLoad(Filename);			// Nata obrzok a vrti pointer
	}
	return NULL;									// Ak sa obrzok nenatal vrti NULL
}

int LoadGLTextures()								// Nata obrzky a uloi ako textury
{
	int Status=TRUE,i;								// indikator
	AUX_RGBImageRec *TextureImage;					// miesto pre truktru

	for(i=0;i<POCET_TEXTUR;i++)
	{	
		TextureImage=NULL;
		if (TextureImage=LoadBMP(texture_name[i]))
		{
			glGenTextures(1, &texture[i]);						//generovanie cislel pre textury
			glBindTexture(GL_TEXTURE_2D, texture[i]);			//vyber textury
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);		//nastavenie filtra
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);		//nastavenie filtra
				//nacitanie textury do (grafickej) karty
			glTexImage2D(GL_TEXTURE_2D, 0, 3, TextureImage->sizeX, TextureImage->sizeY, 0, GL_RGB, GL_UNSIGNED_BYTE, TextureImage->data);
		}
		else 
		{	MessageBox(NULL,"Chyba natania obrzka.",texture_name[i],MB_ICONERROR);Status=false;}

		if (TextureImage)									// Ak textura existuje
		{
			if (TextureImage->data)free(TextureImage->data);// ak existuju data uvoni z pamte
			free(TextureImage);								// uvoni truktru
		}
	}
	return Status;
}

// vytvor Display List
GLuint BuildList_Kocka(GLuint boxDisplay)
{
	if(boxDisplay)glDeleteLists(boxDisplay,1);			// ak je vybudovany zmas
	boxDisplay=glGenLists(1);							// generuj 1 novy prazny Dispay List
	glNewList(boxDisplay,GL_COMPILE);					// start noveho Display Listu
	// tu je vsetko co sa nakresli ked zavolame tento display list
	glBegin(GL_QUADS);
		// Front Face
		glNormal3f(-0.577f,-0.577f, 0.577f);glTexCoord2f(0.0f, 0.0f); glVertex3f(-1.0f, -1.0f,  1.0f);
		glNormal3f( 0.577f,-0.577f, 0.577f);glTexCoord2f(1.0f, 0.0f); glVertex3f( 1.0f, -1.0f,  1.0f);
		glNormal3f( 0.577f, 0.577f, 0.577f);glTexCoord2f(1.0f, 1.0f); glVertex3f( 1.0f,  1.0f,  1.0f);
		glNormal3f(-0.577f, 0.577f, 0.577f);glTexCoord2f(0.0f, 1.0f); glVertex3f(-1.0f,  1.0f,  1.0f);
		// Back Face
		glNormal3f(-0.577f,-0.577f,-0.577f);glTexCoord2f(1.0f, 0.0f); glVertex3f(-1.0f, -1.0f, -1.0f);
		glNormal3f(-0.577f, 0.577f,-0.577f);glTexCoord2f(1.0f, 1.0f); glVertex3f(-1.0f,  1.0f, -1.0f);
		glNormal3f( 0.577f, 0.577f,-0.577f);glTexCoord2f(0.0f, 1.0f); glVertex3f( 1.0f,  1.0f, -1.0f);
		glNormal3f( 0.577f,-0.577f,-0.577f);glTexCoord2f(0.0f, 0.0f); glVertex3f( 1.0f, -1.0f, -1.0f);
		// Top Face
		glNormal3f(-0.577f, 0.577f,-0.577f);glTexCoord2f(0.0f, 1.0f); glVertex3f(-1.0f,  1.0f, -1.0f);
		glNormal3f(-0.577f, 0.577f, 0.577f);glTexCoord2f(0.0f, 0.0f); glVertex3f(-1.0f,  1.0f,  1.0f);
		glNormal3f( 0.577f, 0.577f, 0.577f);glTexCoord2f(1.0f, 0.0f); glVertex3f( 1.0f,  1.0f,  1.0f);
		glNormal3f( 0.577f, 0.577f,-0.577f);glTexCoord2f(1.0f, 1.0f); glVertex3f( 1.0f,  1.0f, -1.0f);
		// Bottom Face
		glNormal3f(-0.577f,-0.577f,-0.577f);glTexCoord2f(1.0f, 1.0f); glVertex3f(-1.0f, -1.0f, -1.0f);
		glNormal3f( 0.577f,-0.577f,-0.577f);glTexCoord2f(0.0f, 1.0f); glVertex3f( 1.0f, -1.0f, -1.0f);
		glNormal3f( 0.577f,-0.577f, 0.577f);glTexCoord2f(0.0f, 0.0f); glVertex3f( 1.0f, -1.0f,  1.0f);
		glNormal3f(-0.577f,-0.577f, 0.577f);glTexCoord2f(1.0f, 0.0f); glVertex3f(-1.0f, -1.0f,  1.0f);
		// Right face
		glNormal3f( 0.577f,-0.577f,-0.577f);glTexCoord2f(1.0f, 0.0f); glVertex3f( 1.0f, -1.0f, -1.0f);
		glNormal3f( 0.577f, 0.577f,-0.577f);glTexCoord2f(1.0f, 1.0f); glVertex3f( 1.0f,  1.0f, -1.0f);
		glNormal3f( 0.577f, 0.577f, 0.577f);glTexCoord2f(0.0f, 1.0f); glVertex3f( 1.0f,  1.0f,  1.0f);
		glNormal3f( 0.577f,-0.577f, 0.577f);glTexCoord2f(0.0f, 0.0f); glVertex3f( 1.0f, -1.0f,  1.0f);
		// Left Face
		glNormal3f(-0.577f,-0.577f,-0.577f);glTexCoord2f(0.0f, 0.0f); glVertex3f(-1.0f, -1.0f, -1.0f);
		glNormal3f(-0.577f,-0.577f, 0.577f);glTexCoord2f(1.0f, 0.0f); glVertex3f(-1.0f, -1.0f,  1.0f);
		glNormal3f(-0.577f, 0.577f, 0.577f);glTexCoord2f(1.0f, 1.0f); glVertex3f(-1.0f,  1.0f,  1.0f);
		glNormal3f(-0.577f, 0.577f,-0.577f);glTexCoord2f(0.0f, 1.0f); glVertex3f(-1.0f,  1.0f, -1.0f);
	glEnd();

	glEndList();			//koniec display listu
	return boxDisplay;
}