#ifndef _INIT_H
#define _INIT_H

#include <windows.h>	// hlavikov sbor Windows kninice
#include <gl\gl.h>		// hlavikov sbor OpenGL32 kninice
#include <gl\glu.h>		// hlavikov sbor GLu32 kninice
#include <gl\glaux.h>	// hlavikov sbor GLaux kninice 

#include <stdlib.h>
#include <stdarg.h>
#include <stdio.h>
#include <math.h>

#define obraz_x 800			//horizontalne rozlisenie
#define obraz_y 600			//vertikalne rozlisenie
#define obraz_bit 16		//pocet bitov na 1 pixel

extern	HDC			hDC;		// privtny GDI Device Context
extern	HWND		hWnd;		// Handle na okno
extern	HINSTANCE	hInstance;	// Intalacia programu
extern bool	keys[256];			// pole - prca s klavesnicou

extern UINT g_FontListID;

//init.cpp
LRESULT	CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);	// Declaration For WndProc
extern	GLfloat LightPosition[4];

//0XX.cpp
void DrawGLScene(void);				//deklaracia funkcie, v tejto funkcii je vsetko co sa ma vykreslit
int LoadGLTextures(void);

//bitmap_font.cpp
extern GLuint	texture[];
extern GLuint	base;				// Base Display List For The Font
GLvoid BuildFont(GLvoid);
GLvoid KillFont(GLvoid);
GLvoid glPrint(GLint , GLint , char *, int ); //x,y,*string,set
GLvoid glPrint_(GLint , GLint , char *, int ); //x-stlpec,y-riadok,*string,set
GLvoid glPrintFast(GLint , GLint , char *, int );

//timer.cpp
typedef struct			 								// truktra pre asova
{
  __int64       frekvencia;								// frekvencia asovaa
  float         perioda;								// perida asovaa
  unsigned long mm_timer_start;							// tart tandartnho asovaa - v milisekundch
  bool			performance_timer;						// pouit rchli asova ? | Using The Performance Timer?
  __int64       performance_timer_start;				// tartovn hodnota rchleho asovaa
} TIMER;

extern TIMER timer0,timer1;
float TimerGetTime(TIMER*);
void TimerReset(TIMER*);
void TimerInit(TIMER*);

#endif