#include "init.h"

/*typedef struct			 								// truktra pre asova
{
  __int64       frekvencia;								// frekvencia asovaa
  float         perioda;								// perida asovaa
  unsigned long mm_timer_start;							// tart tandartnho asovaa - v milisekundch
  bool			performance_timer;						// pouit rchli asova ? | Using The Performance Timer?
  __int64       performance_timer_start;				// tartovn hodnota rchleho asovaa
} TIMER;*/

TIMER timer0;

void TimerInit(TIMER* timer)							// inicializcia oasovaa
{
	memset(timer, 0, sizeof(TIMER));					// znulovanie truktry

	// zistenie i rchli asova je pouiten
	if (!QueryPerformanceFrequency((LARGE_INTEGER *) &(timer->frekvencia) ) )
	{
		// rchli asova nepodporovan hardwarom
		timer->performance_timer	= FALSE;					// nastav Performance Timer na false
		timer->mm_timer_start		= timeGetTime();			// pouitm timeGetTime() nastav tartovaciu hodnotu
		timer->perioda				= 1.0f/1000.0f;				// nastav periodu na 1 ms
		timer->frekvencia			= 1000;						// nastav frekvenciu na 1000 Hz
	}
	else
	{
		// rchli asova je prstupn
		QueryPerformanceCounter((LARGE_INTEGER *) &(timer->performance_timer_start) );	//nastavenie tartovacej hodnoty
		timer->performance_timer	= TRUE;				// nastav Performance Timer na TRUE
		timer->perioda = (float) (((double)1.0f)/((double)timer->frekvencia));	// vypotanie peridy
	}
}

float TimerGetTime(TIMER* timer)					// vrti as v sekundch
{
	__int64 time;									// na uloenie aktulnej hodnoty asovaa

	if (timer->performance_timer)					// je pouit rchli asova (Performance Timer ) ?
	{
		QueryPerformanceCounter((LARGE_INTEGER *) &time);	// natanie aktulnej hodnoty asovaa
		// vrti aktulnu hodnotu minus tartovaciu hodnotu nasoben peridou
		return ( (float) ( time - timer->performance_timer_start) * timer->perioda);
	}
	else
	{	return( (float) ( timeGetTime() - timer->mm_timer_start) * timer->perioda);}	// vrti poet seknd od tartu
}

void TimerReset(TIMER* timer)
{	
	if (timer->performance_timer)					// je pouit rchli asova (Performance Timer ) ?
	{	QueryPerformanceCounter((LARGE_INTEGER *) &(timer->performance_timer_start) );}
	else
	{	timer->mm_timer_start = timeGetTime();}
}